petsc-3.7.7 2017-09-25
Report Typos and Errors

# DMProjectFunction

This projects the given function into the function space provided.

### Synopsis

    #include "petscdm.h"
    #include "petscdmlabel.h"
    PetscErrorCode DMProjectFunction(DM dm, PetscReal time, PetscErrorCode (**funcs)(PetscInt, PetscReal, const PetscReal [], PetscInt, PetscScalar *, void *), void **ctxs, InsertMode mode, Vec X)

### Input Parameters

| dm | - The DM
| time | - The time
| funcs | - The coordinate functions to evaluate, one per field
| ctxs | - Optional array of contexts to pass to each coordinate function. ctxs itself may be null.
| mode | - The insertion mode for values

### Output Parameter

X -vector

### Calling sequence of func

       func(PetscInt dim, PetscReal time, const PetscReal x[], PetscInt Nf, PetscScalar u[], void *ctx);

| dim | - The spatial dimension
| x | - The coordinates
| Nf | - The number of fields
| u | - The output field values
| ctx | - optional user-defined function context

### See Also

DMComputeL2Diff()

Level:developer
Location:src/dm/interface/dm.c
Index of all DM routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/snes/examples/tutorials/ex12.c.html
src/snes/examples/tutorials/ex62.c.html
src/snes/examples/tutorials/ex77.c.html
src/ts/examples/tutorials/ex11.c.html